gtk-sharp 2.12.0.0 Gtk# is thread aware, but not thread safe; See the Gtk# Thread Programming for details. GLib.Object Gtk.TreeDragDest Gtk.TreeDragSource Gtk.TreeModel Gtk.TreeSortable System.Collections.IEnumerable The ListStore is a columned list data structure to be used with widget.

Iteration: In new versions of Gtk# (2.0 and up) this class implements the interface, so code can be written like this:

`void DumpColumnValues (ListStore store, int col) { foreach (object[] row in store) Console.WriteLine ("Value of column {0} is {1}", col, row [col]); }`

- Constructor
  2.12.0.0
  Protected constructor.
- Constructor
  2.12.0.0
  System.Obsolete
  a
  Protected Constructor.
  Chain to this constructor if you have manually registered a native value for your subclass.
- Constructor
  2.12.0.0
  System.ParamArray
  a
  Default constructor.
- Constructor
  2.12.0.0
  Pointer to the C object.
  Internal constructor

  This is an internal constructor, and should not be used by user code.

- Constructor
  2.12.0.0
  System.ParamArray
  a
  Creates a new store. The columns' type specified by the argument.
  ListStore ls = new ListStore (typeof (string), typeof (int), typeof (double)); ...
  The above example creates a new three columns list store. The types of the columns are , , and .
- Method
  2.12.0.0
  Gtk.TreeIter Appends a new row to the ListStore. a that points to the new row. The row will be empty before this function is called. To set the value of the new row, use .
- Method
  2.12.0.0
  Gtk.TreeIter `` a with as many elements as the ListStore has columns. Appends a new row to the ListStore and puts the contents of in it. a pointing to the new row
- Method
  2.12.0.0
  Gtk.TreeIter `System.ParamArray` a list , one item for each column of a row. Appends a new row to the ListStore and puts the objects in in it. a pointing to the new row
- Method
  2.12.0.0
  System.Void Emits a event.
- Method
  2.12.0.0
  System.Void Removes all data from the store.
- Property
  2.12.0.0
  GLib.GType[] The types in each column of a ListStore. a This property is meant primarily for classes that inherit from , and should only be used when constructing a new . It will not function after a row has been added or after a method on the interface has been called.
- Property
  2.12.0.0
  Gtk.TreeIterCompareFunc The function that will be used by default to sort columns. a
- Method
  2.12.0.0
  System.Boolean `` A , the path of the data to delete. When this ListStore is the data source for a drag operation and the drag operation is a move, this method runs to delete the data after the data has been received by the target widget. A , true if the operation succeeds.
- Method
  2.12.0.0
  System.Boolean `` `` a A Method used when this ListStore is part of a source widget for a drag-and-drop operation; gets the data that was dragged from the associated widget. A , true if the operation succeeded.
- Method
  2.12.0.0
  System.Boolean `` `` A , the destination path of the drag A , the data that was dragged Drags data received into this object. A boolean, true if the data was successfully received.
- Method
  2.12.0.0
  System.Void `` `` a a Fires a event. Call this after changing a row so that the view widget for this ListStore will update.
- Method
  2.12.0.0
  System.Void `` a to pass to the event. Fires a event.
- Method
  2.12.0.0
  System.Void `` `` a to pass to the event a to pass to the event Emits a event. This is meant to be called whenever the child state of a node changes. This is mandated by the , but it shouldn't get used much for ListStores because they don't generally have child nodes.
- Method
  2.12.0.0
  System.Void `` `` a to pass to the event. a see cref="T:Gtk.TreeIter" /> to pass to the event. Fires a event.
- Method
  System.Int32 `` `` Fires a event. a , pointer to the row whose children have been reordered a , pointer to the row whose children have been reordered a This is part of the implementation of . It should be called by other class methods that reorder rows so that the proper events are raised. (FIXME: since lists don't have parents/children, how does this get used in practice? There should be an example here.)
- Method
  2.12.0.0
  System.Void `` `` `` To be added. To be added. To be added. To be added. To be added.
- Property
  2.12.0.0
  Gtk.TreeModelFlags The flags for this ListStore. A Flags are about the shape of this object's data; see the class documentation for more details.
- Method
  2.12.0.0
  System.Void `` A to run over every row. Runs a method on every row of a ListStore.
- Method
  2.12.0.0
  GLib.GType `` a , the column to check Gets the type of data stored in column number . a
- Method
  2.12.0.0
  System.Collections.IEnumerator

  Returns a for the current instance. The enumerated items are object arrays containing the column values for each row.

  A enumerating items of type [].

  If the elements of the current instance are modified while an enumeration is in progress, a call to or throws .

- Method
  2.12.0.0
  System.Boolean `` `` a to set to point to the row. a Gets an iterator object for the given . A , true if the row exists
- Method
  2.12.0.0
  System.Boolean `` A to reset Initializes with the first iterator in the ListStore (the top item). A , true if the operation is successful, false if the ListStore is empty.
- Method
  2.12.0.0
  System.Boolean `` `` a to be set by this method A path string Marshals a path string into a object that points to a row in this tree. A , true if this string is a valid path for this ListStore.
- Method
  2.12.0.0
  Gtk.TreePath `` a Turns a specified by into a . a
- Method
  2.12.0.0
  System.Boolean `` `` a , gets filled with the column number that's currently used for sorting a , the current type of sort (ascending or descending) Report on which column is currently being used to sort this ListStore. a , false if the default sort column for this ListStore is being used, true if some other sort column is being used.
- Method
  2.12.0.0
  System.String `` a Marshals the given into a path string. a
- Method
  2.12.0.0
  System.Void `` `` an object of type a , pointer to the va_list data structure of arguments (FIXME: clarify what va_lists look like) Gets the values of child properties for the row pointed to by .
- Method
  2.12.0.0
  System.Object `` `` a , the row to look in a , the column number to look in Gets the data from row of column . a
- Method
  2.12.0.0
  System.Void `` `` `` a a a Gets the value of row of column and puts it in .
- Property
  2.12.0.0
  GLib.GType GType Property. a Returns the native value for .
- Property
  2.12.0.0
  System.Boolean Find out whether this ListStore has a default sort function. a , true if there is a default sort function. To set a default sort function, use the property.
- Method
  2.12.0.0
  Gtk.TreeIter `` a Inserts a new row at position . a pointing to the new row. If is larger than the number of rows on the list, then the new row will be appended to the list. The row will be empty before this function is called. To set the value of the new row, use .
- Method
  2.12.0.0
  Gtk.TreeIter `` a , the row to insert before Inserts a new row after . If is null, then the row will be appended to the end of the list. a that points to the new row The row will be empty before this function is called. To set the value of the new row, use .
- Method
  2.12.0.0
  Gtk.TreeIter `` a , the row to insert before Inserts a new row before . If is null, then the row will be appended to the end of the list. a that points to the new row The row will be empty before this function is called. To set the value of the new row, use .
- Method
  2.12.0.0
  Gtk.TreeIter `` `System.ParamArray` Insert position. An array of column values to set. Inserts a row into the store at a given position with column values. An iter pointing to the inserted row. The values provided should be in column order.
- Method
  2.12.0.0
  System.Obsolete
  System.Int32 `` `` `` `` a a a a To be added a To be added
- Method
  2.12.0.0
  System.Boolean `` an object of type Sets to point to the first child of . an object of type , , if has been set to the first child.

  If has no children, is returned and is set to be invalid. will remain a valid node after this function has been called.

  If is returns the first node, equivalent to `gtk_tree_model_get_iter_first (tree_model, iter);`

- Method
  2.12.0.0
  System.Boolean `` `` , an object that will be set to point to the first child. a , the parent row. A , true if has children. In general, this will return false, as ListStore isn't tree-shaped. However, if is , will return the list itself, since they're all children of the root.
- Method
  2.12.0.0
  System.Boolean `` a Tests whether a given row has a child node. A , always false for ListStores. This is mandated by
- Method
  2.12.0.0
  System.Boolean `` a Test whether is valid for this ListStore. a , true if is valid. WARNING: this method is slow and is only intended for debugging/testing purposes.
- Method
  2.12.0.0
  System.Int32 Returns the number of children that the toplevel node has. Is used to retrieve the number of rows in the . an object of type , the number of children of . As a special case, if is , then the number of toplevel nodes is returned.
- Method
  2.12.0.0
  System.Int32 `` a Returns the number of children that has. If is null, as in the case of all ListStore objects, this will return the number of top-level items. a FIXME: Why does ListStore.custom call gtk_tree_model_iter_n_children?
- Method
  2.12.0.0
  System.Boolean `` a Advances to the next row. a for whether the operation succeeded.
- Method
  2.12.0.0
  System.Boolean `` `` a a Sets to be the child of this ListStore, using the given index. The first index is 0. If is too big, or this ListStore has no rows, is set to an invalid iterator and false is returned. For ListStore objects, the th root node is set, since they don't have a tree-like structure. a , true if has an th child. This is a custom binding for Gtk# which assumes that the current object is the parent. An alternate invocation form that parallels the C API is available.
- Method
  2.12.0.0
  System.Boolean `` `` `` a To be added. a Sets to be the child of , using the given index. The first index is 0. If is too big, or has no children, is set to an invalid iterator and false is returned. will remain a valid node after this function has been called. As a special case, if is , then the th root node is set. a , true if has an th child. This invocation form is closer to the underlying C API, but it's probably less useful for most C# purposes.
- Method
  2.12.0.0
  System.Boolean `` `` a to set to point to the row. a , the child row whose parent we want to get Gets the parent row of . A , true if the parent exists. Since ListStore objects aren't tree-shaped, this will always return false.
- Method
  2.12.0.0
  System.Void `` `` a a Move the row pointed to by to the position after . If is , will be moved to point to the start of the list. This only works in unsorted stores.
- Method
  2.12.0.0
  System.Void `` `` a a Move the row pointed to by to the position before . If is , will be moved to point to the end of the list. This only works in unsorted stores.
- Property
  2.12.0.0
  System.Int32 The number of columns in this ListStore. A
- Method
  2.12.0.0
  GLib.DefaultSignalHandler(ConnectionMethod="OverrideRowChanged", Type=typeof(Gtk.ListStore))
  System.Void `` `` a a Default handler for the event. Override this method in a subclass to provide a default handler for the event.
- Method
  2.12.0.0
  GLib.DefaultSignalHandler(ConnectionMethod="OverrideRowDeleted", Type=typeof(Gtk.ListStore))
  System.Void `` a Default handler for the event. Override this method in a subclass to provide a default handler for the event.
- Method
  2.12.0.0
  GLib.DefaultSignalHandler(ConnectionMethod="OverrideRowHasChildToggled", Type=typeof(Gtk.ListStore))
  System.Void `` `` a a Default handler for the event. Override this method in a subclass to provide a default handler for the event.
- Method
  2.12.0.0
  GLib.DefaultSignalHandler(ConnectionMethod="OverrideRowInserted", Type=typeof(Gtk.ListStore))
  System.Void `` `` a a Default handler for the event. Override this method in a subclass to provide a default handler for the event.
- Method
  2.12.0.0
  GLib.DefaultSignalHandler(ConnectionMethod="OverrideRowsReordered", Type=typeof(Gtk.ListStore))
  System.Obsolete("Replaced by int[] new_order overload.")
  System.Void `` `` `` a a a Default handler for the event. Override this method in a subclass to provide a default handler for the event.
- Method
  2.12.0.0
  GLib.DefaultSignalHandler(ConnectionMethod="OverrideRowsReordered", Type=typeof(Gtk.ListStore))
  System.Void `` `` `` Path to the reordered parent node. Iter corresponding to the reordered parent node. An array of the old indices. Default handler for the RowsReordered event.
- Method
  2.12.0.0
  GLib.DefaultSignalHandler(ConnectionMethod="OverrideSortColumnChanged", Type=typeof(Gtk.ListStore))
  System.Void Default handler for the event. Override this method in a subclass to provide a default handler for the event.
- Method
  2.12.0.0
  Gtk.TreeIter Adds a new row to the beginning of the list. a pointing to the new row. The row will be empty before this function is called. To set the value of the new row, use .
- Method
  2.12.0.0
  System.Void `` a Lets the ListStore reference the row pointed to by .

  This function is primarily meant as a way for views to let caching model know when nodes are being displayed (and hence, whether or not to cache that node.) For example, a file-system based model would not want to keep the entire file-hierarchy in memory, just the sections that are currently being displayed by every current view.

  A model should be expected to be able to get an iter independent of its reffed state.

- Method
  2.12.0.0
  System.Boolean `` a Removes a row from the store. a After being removed, is set to be the next valid row, or invalidated if it pointed to the last row in the store.
- Method
  2.12.0.0
  System.Obsolete("Replaced by Reorder (int[]) overload")
  System.Int32 Reorders the ListStore. a . (FIXME: Does this binding work?)
- Method
  2.12.0.0
  System.Void `` To be added. To be added. To be added.
- Event
  2.12.0.0
  GLib.Signal("row_changed")
  Gtk.RowChangedHandler Raised when a row has changed.
- Event
  2.12.0.0
  GLib.Signal("row_deleted")
  Gtk.RowDeletedHandler Raised when a row is deleted.
- Method
  2.12.0.0
  System.Boolean `` a Returns whether or not a given row can be dragged. A boolean, true if the row is draggable.
- Method
  2.12.0.0
  System.Boolean `` `` A A Returns true if the row at can have dropped on it. A boolean.
- Event
  2.12.0.0
  GLib.Signal("row_has_child_toggled")
  Gtk.RowHasChildToggledHandler Raised when the display of a given row's children is toggled.
- Event
  2.12.0.0
  GLib.Signal("row_inserted")
  Gtk.RowInsertedHandler Raised when a row of data is inserted.
- Event
  2.12.0.0
  GLib.Signal("rows_reordered")
  Gtk.RowsReorderedHandler Raised when the order of rows has changed.
- Method
  2.12.0.0
  System.Obsolete("Replaced by ColumnTypes property.")
  System.Void `` a Deprecated method to set what types go in each column of a ListStore. See
- Method
  2.12.0.0
  System.Obsolete("Replaced by DefaultSortFunc property.")
  System.Void `` `` `` A ignored ignored Set the function that will be used by default to sort columns. This method is obsolete. The property is preferred for new code.
- Method
  2.12.0.0
  System.Void `` `` A , the column number to sort by. A Sets the column number to sort by.
- Method
  2.12.0.0
  System.Void `` `` A for the column number. A Sets a sort function to be used for the column .
- Method
  2.12.0.0
  System.Obsolete("Replaced by SetSortFunc (int, TreeIterCompareFunc) overload.")
  System.Void `` `` `` `` A for the column number. A ignored ignored Sets a sort function to be used for the column . This overload is obsolete. The two parameter overload is preferred for new code.
- Method
  2.12.0.0
  System.Void `` `` an object of type a , pointer to the va_list data structure of arguments (FIXME: clarify what va_lists look like) Sets the values of child properties for the row pointed to by .
- Method
  2.12.0.0
  System.Void `` `` `` a a , the column number a Sets the value of the specified column in the row pointed by . The type of specified column must be a .
- Method
  2.12.0.0
  System.Void `` `` `` a a a Sets the value of the specified column in the row pointed by iter. The type of specified column must be a .
- Method
  2.12.0.0
  System.Void `` `` `` a a a Sets the value of the specified column in the row pointed by iter. The type of specified column must be a .
- Method
  2.12.0.0
  System.Void `` `` `` a a a Sets the value of the specified column in the row pointed by iter. The type of specified column must be an .
- Method
  2.12.0.0
  System.Void `` `` `` a a a Sets the value of the specified column in the row pointed by iter. The type of specified column must be an .
- Method
  2.12.0.0
  System.Void `` `` `` a a a Sets the value of the specified column in the row pointed by iter. The type of specified column must be an
- Method
  2.12.0.0
  System.Void `` `` `` a a a Sets the value of the specified column in the row pointed by iter. The type of specified column must be a .
- Method
  2.12.0.0
  System.Void `` `` `` a a a Sets the value of the specified column in the row pointed by iter. The type of specified column must be an .
- Method
  2.12.0.0
  System.Void `` `System.ParamArray` Update position. An array of column values to set. Sets the column values for a given row. The values provided must be in column order.
- Event
  2.12.0.0
  GLib.Signal("sort_column_changed")
  System.EventHandler Raised when the sorting column has changed.
- Method
  2.12.0.0
  System.Void `` `` a a Swaps rows a and b in the store. This is only works in unsorted stores.
- Method
  2.12.0.0
  System.Void `` a Lets the ListStore unref the row at .

  This is an optional method for models to implement. To be more specific, models may ignore this call as it exists primarily for performance reasons.

  For more information on what this means, see . Please note that nodes that are deleted are not unreffed.